diff -u -Naur eperl-2.2.14/README eperl-2.2.14.fink/README
--- eperl-2.2.14/README	Sun Aug  2 09:22:25 1998
+++ eperl-2.2.14.fink/README	Wed Nov 17 12:45:58 2004
@@ -15,9 +15,9 @@
   scripting language for dynamic HTML page programming. 
 
   The documentation and latest release can be found on
-  http://www.engelschall.com/sw/eperl/
+  http://www.ossp.org/pkg/tool/eperl/
 
-  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 
   This program is free software; it may be redistributed and/or modified only
   under the terms of either the Artistic License or the GNU General Public
diff -u -Naur eperl-2.2.14/acconfig.h eperl-2.2.14.fink/acconfig.h
--- eperl-2.2.14/acconfig.h	Fri Jul 10 03:51:33 1998
+++ eperl-2.2.14.fink/acconfig.h	Wed Nov 17 12:45:58 2004
@@ -2,7 +2,7 @@
 #define CONFIG_AC_H
 /*
 **  config_ac.h -- AUTO configuration header file
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 */
 
 @TOP@
diff -u -Naur eperl-2.2.14/config_ac.h.in eperl-2.2.14.fink/config_ac.h.in
--- eperl-2.2.14/config_ac.h.in	Fri Jul 10 03:52:55 1998
+++ eperl-2.2.14.fink/config_ac.h.in	Wed Nov 17 12:45:58 2004
@@ -3,7 +3,7 @@
 #define CONFIG_AC_H
 /*
 **  config_ac.h -- AUTO configuration header file
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 */
 
 
diff -u -Naur eperl-2.2.14/config_sc.h.in eperl-2.2.14.fink/config_sc.h.in
--- eperl-2.2.14/config_sc.h.in	Tue Dec 30 02:32:33 1997
+++ eperl-2.2.14.fink/config_sc.h.in	Wed Nov 17 12:45:58 2004
@@ -9,7 +9,6 @@
 
 #define AC_perl_prog      "@perl_prog@"
 #define AC_perl_vers      "@perl_vers@"
-#define AC_perl_vnum      @perl_vnum@
 #define AC_perl_archlib   "@perl_archlib@"
 #define AC_perl_libs      "@perl_libs@"
 #define AC_perl_dla       "@perl_dla@"
diff -u -Naur eperl-2.2.14/configure.in eperl-2.2.14.fink/configure.in
--- eperl-2.2.14/configure.in	Wed Dec 31 03:22:16 1997
+++ eperl-2.2.14.fink/configure.in	Wed Nov 17 12:45:58 2004
@@ -5,20 +5,23 @@
 dnl ##  Process this file with ``autoconf'' to produce a configure script.
 dnl ##
 
-
 dnl #
 dnl #   standard autoconf prolog
 dnl #
 
 AC_PREREQ(2.10)dnl
-AC_REVISION($Revision: 2.0$)
-echo "Configuring for ePerl `./etc/newvers -l c -D eperl_version.c`"
-
-AC_CONFIG_AUX_DIR(etc)
+AC_REVISION($Revision: 1.9 $)
 AC_INIT(README)
 AC_CONFIG_HEADER(config_ac.h)dnl
 AC_PREFIX_DEFAULT(/usr/local)
 
+shtool=./etc/shtool
+TERM_BOLD=`$shtool echo -e %B 2>/dev/null`
+TERM_NORM=`$shtool echo -e %b 2>/dev/null`
+
+dnl ##  version id
+EPERL_VERSION="`$shtool version -lc -d long eperl_version.c`"
+echo "${TERM_BOLD}Configuring for ePerl ${EPERL_VERSION}${TERM_NORM}"
 
 dnl #
 dnl #   libdir adjustment
@@ -32,6 +35,8 @@
 esac
 AC_SUBST(libsubdir)
 
+tmpdir=${TMPDIR-/tmp}
+AC_SUBST(tmpdir)
 
 dnl #
 dnl #   latest find Perl interpreter
@@ -40,65 +45,50 @@
 AC_CONFIGURE_PART(CHECK: Configuration of Perl Language)
 AC_MSG_CHECKING([for Perl language])
 AC_ARG_WITH(perl,dnl
-[  --with-perl=PATH        force the usage of a specific installed Perl],
+[  --with-perl=PATH        force the usage of a specific Perl 5 interpreter],[
+dnl [[
 perlprog=$with_perl
-perlvers=`$perlprog -v | grep version | sed -e 's/.* version //' -e 's/ built.*//' -e 's/ with.*//'`
-,
-TMPFILE=/tmp/x.$$
-rm -f $TMPFILE
-touch $TMPFILE
-c=0
-for dir in `echo $PATH | sed -e 's/:/ /g'` /tmp; do
+perlvers=`$perlprog -e 'printf "%.3f",$]'`
+dnl ]
+],[
+perlvers=
+for dir in `echo $PATH | sed -e 's/:/ /g'` $tmpdir; do
     for perl in perl5 perl miniperl; do
          if test -f "$dir/$perl"; then
              if test -x "$dir/$perl"; then
-                 perl="$dir/$perl"
-                 version=`$perl -v | grep version | sed -e 's/.* version //' -e 's/ built.*//' -e 's/ with.*//'`
-                 versionnum="`echo $version | sed -e 's/\.//g' -e 's/_//g'`"
-                 versionnum=`expr $versionnum - $c`
-                 echo "$versionnum $version $perl" >>$TMPFILE
+                 perlprog="$dir/$perl"
+                 if $perlprog -e 'require 5.003'; then
+dnl [[
+                     perlvers=`$perlprog -e 'printf "%.3f",$]'`
+dnl ]
+                     break 2
+                 fi
              fi
          fi
     done
-    c=`expr $c + 1`
 done
-perlvers="`cat $TMPFILE | sort -u | tail -1 | cut '-d ' -f2`"
-perlprog="`cat $TMPFILE | sort -u | tail -1 | cut '-d ' -f3`"
-rm -f $TMPFILE
-)dnl
+])dnl
 PATH_PERL=$perlprog
 AC_MSG_RESULT([$perlprog v$perlvers])
-case $perlvers in
-    5.003* | 5.004* | 5.005* | 5.006* )
-        ;;
-    * ) echo ""
-        echo "Latest Perl found on your system is $perlvers,"
-        echo "but at least Perl version 5.003 is required."
-        echo "In case the newer one is not in PATH, just use"
-        echo "the option --with-perl=/path/to/bin/perl to"
-        echo "provide the correct executable."
-        echo ""
-        AC_ERROR([Perl version too old]) 
-        ;;
-esac
-case $perlvers in
-    5.00[[3-6]_[0-9][0-9]] ) 
-	    perlvnum=`echo $perlvers | sed -e 's/\.//' -e 's/_//'` ;; 
-    5.00[[3-6]] ) 
-	    perlvnum=`echo $perlvers | sed -e 's/\.//' -e 's/$/00/'` ;; 
-	* ) 
-	    perlvnum=`echo $perlvers | sed -e 's/\.//' -e 's/_//'` ;; 
-esac
+if $perlprog -e 'require 5.003'; then
+    :
+else
+    echo ""
+    echo "Latest Perl found on your system is $perlvers,"
+    echo "but at least Perl version 5.003 is required."
+    echo "In case the newer one is not in PATH, just use"
+    echo "the option --with-perl=/path/to/bin/perl to"
+    echo "provide the correct executable."
+    echo ""
+    AC_ERROR([Perl version too old]) 
+fi
 AC_SUBST(PATH_PERL)
 AC_SUBST(perlprog)
 AC_SUBST(perlvers)
-AC_SUBST(perlvnum)
 perl_prog=$perlprog
 perl_vers=$perlvers
-perl_vnum=$perlvnum
 AC_SUBST(perl_prog)
 AC_SUBST(perl_vers)
-AC_SUBST(perl_vnum)
 if test -f $PATH_PERL; then
     :
 else
@@ -256,10 +246,6 @@
 fi
 
 AC_SET_MAKE
-AC_PROG_INSTALL
-INSTALL_DATA='${INSTALL} -m 644'
-INSTALL_PROGRAM="${INSTALL_PROGRAM} -m 755"
-
 
 dnl #
 dnl #   determine system parameters
@@ -290,9 +276,5 @@
 config_sc.h dnl
 ,dnl
 )dnl
-
-echo ""
-echo "Now please type 'make' to compile. Good luck."
-echo ""
 
 dnl ##EOF##
diff -u -Naur eperl-2.2.14/eg/demo.func.phtml eperl-2.2.14.fink/eg/demo.func.phtml
--- eperl-2.2.14/eg/demo.func.phtml	Mon Nov 17 10:00:47 1997
+++ eperl-2.2.14.fink/eg/demo.func.phtml	Wed Nov 17 12:45:58 2004
@@ -22,8 +22,8 @@
                 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec' );
     my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = 
         localtime($time);
-    my ($str) = sprintf("%s %s %2d %02d:%02d:%02d 19%s%s",
-         $dow[$wday], $moy[$mon], $mday, $hour, $min, $sec, $year, 
+    my ($str) = sprintf("%s %s %2d %02d:%02d:%02d %s%s",
+         $dow[$wday], $moy[$mon], $mday, $hour, $min, $sec, $year+1900, 
          $isdst ?  " DST" : "");
     return $str;
 }
diff -u -Naur eperl-2.2.14/eperl.pod eperl-2.2.14.fink/eperl.pod
--- eperl-2.2.14/eperl.pod	Mon Nov 17 04:50:52 1997
+++ eperl-2.2.14.fink/eperl.pod	Wed Nov 17 12:45:58 2004
@@ -898,7 +898,7 @@
 Web-References:
 
   Perl:   perl(1),  http://www.perl.com/
-  ePerl:  eperl(1), http://www.engelschall.com/sw/eperl/
+  ePerl:  eperl(1), http://www.ossp.org/pkg/tool/eperl/
   Apache: httpd(8), http://www.apache.org/
 
 =cut
diff -u -Naur eperl-2.2.14/eperl_config.c eperl-2.2.14.fink/eperl_config.c
--- eperl-2.2.14/eperl_config.c	Fri Jul 10 03:50:11 1998
+++ eperl-2.2.14.fink/eperl_config.c	Wed Nov 17 12:45:58 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
diff -u -Naur eperl-2.2.14/eperl_config.h eperl-2.2.14.fink/eperl_config.h
--- eperl-2.2.14/eperl_config.h	Fri Jul 10 03:51:58 1998
+++ eperl-2.2.14.fink/eperl_config.h	Wed Nov 17 12:45:58 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
@@ -255,6 +255,36 @@
 */
 #ifndef NULL
 #define NULL (void *)0
+#endif
+
+
+/*
+**
+**  MAXPATHLEN
+**  PATH_MAX should be used in .c files, but it needs to be
+**  fixed upstream
+*/
+/*  Cut'n'paste from perl.h  */
+#ifndef MAXPATHLEN
+#  ifdef PATH_MAX
+#    ifdef _POSIX_PATH_MAX
+#       if PATH_MAX > _POSIX_PATH_MAX
+/* MAXPATHLEN is supposed to include the final null character,
+ *  * as opposed to PATH_MAX and _POSIX_PATH_MAX. */
+#         define MAXPATHLEN (PATH_MAX+1)
+#       else
+#         define MAXPATHLEN (_POSIX_PATH_MAX+1)
+#       endif
+#    else
+#      define MAXPATHLEN (PATH_MAX+1)
+#    endif
+#  else
+#    ifdef _POSIX_PATH_MAX
+#       define MAXPATHLEN (_POSIX_PATH_MAX+1)
+#    else
+#       define MAXPATHLEN 1024  /* Err on the large side. */
+#    endif
+#  endif
 #endif
 
 
diff -u -Naur eperl-2.2.14/eperl_debug.c eperl-2.2.14.fink/eperl_debug.c
--- eperl-2.2.14/eperl_debug.c	Fri Jul 10 03:50:17 1998
+++ eperl-2.2.14.fink/eperl_debug.c	Wed Nov 17 12:45:58 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
@@ -51,7 +51,8 @@
     va_start(ap, str);
     if (fDebug) {
         if ((fp = fopen(cpDebugFile, "a")) != NULL) {
-            vsprintf(buf, str, ap);
+            vsnprintf(buf, sizeof(buf), str, ap);
+            buf[sizeof(buf)-1] = '\0';
             fprintf(fp, "%s", buf);
             fclose(fp);
         }
diff -u -Naur eperl-2.2.14/eperl_getopt.c eperl-2.2.14.fink/eperl_getopt.c
--- eperl-2.2.14/eperl_getopt.c	Fri Jul 10 03:50:20 1998
+++ eperl-2.2.14.fink/eperl_getopt.c	Wed Nov 17 12:45:58 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
diff -u -Naur eperl-2.2.14/eperl_getopt.h eperl-2.2.14.fink/eperl_getopt.h
--- eperl-2.2.14/eperl_getopt.h	Fri Jul 10 03:52:02 1998
+++ eperl-2.2.14.fink/eperl_getopt.h	Wed Nov 17 12:45:58 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
diff -u -Naur eperl-2.2.14/eperl_global.h eperl-2.2.14.fink/eperl_global.h
--- eperl-2.2.14/eperl_global.h	Mon Jul 27 04:39:30 1998
+++ eperl-2.2.14.fink/eperl_global.h	Wed Nov 17 12:45:58 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
@@ -89,10 +89,8 @@
 /*
 **  Shortcuts for string comparisons
 */
-#define stringEQ(s1,s2)    strcmp(s1,s2)   == 0
-#define stringNE(s1,s2)    strcmp(s1,s2)   != 0
-#define stringEQn(s1,s2,n) strcmp(s1,s2,n) == 0
-#define stringNEn(s1,s2,n) strcmp(s1,s2,n) != 0
+#define stringEQ(s1,s2)    (s1 != NULL && s2 != NULL && strcmp(s1,s2) == 0)
+#define stringNE(s1,s2)    (s1 != NULL && s2 != NULL && strcmp(s1,s2) != 0)
 
 #endif /* EPERL_GLOBAL_H */
 /*EOF*/
diff -u -Naur eperl-2.2.14/eperl_http.c eperl-2.2.14.fink/eperl_http.c
--- eperl-2.2.14/eperl_http.c	Mon Jul 27 03:16:14 1998
+++ eperl-2.2.14.fink/eperl_http.c	Wed Nov 17 12:45:58 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
@@ -37,33 +37,53 @@
 #include "eperl_global.h"
 #include "eperl_proto.h"
 
+#define _EPERL_VERSION_C_AS_HEADER_
+#include "eperl_version.c"
+#undef  _EPERL_VERSION_C_AS_HEADER_
 
 /*
 **  
 **  print a standard HTTP reponse of header lines
 **
 */
-void HTTP_PrintResponseHeaders(char *cpBuf)
+char *HTTP_PrintResponseHeaders(char *cpBuf)
 {
     char *cp;
 
-    if ((cp = getenv("SERVER_PROTOCOL")) == NULL)
-        cp = "HTTP/1.0";
-    printf("%s 200 OK\n", cp);
+    if ((strncmp(cpBuf, "HTTP/1.0 ", 9) == 0
+        || (strncmp(cpBuf, "HTTP/1.1 ", 9) == 0))
+        && (cpBuf[9] >= '1' && cpBuf[9] <= '5')
+        && (cpBuf[10] >= '0' && cpBuf[10] <= '9')
+        && (cpBuf[11] >= '0' && cpBuf[11] <= '9')
+        && (cpBuf[12] == ' ')
+        && ((cp = strchr(cpBuf + 12, '\n')) != NULL)) {
+        /* found HTTP status code */
+        if (*(cp-1) == '\r') {
+            *(cp-1) = '\0';
+        }
+        *cp++ = '\0';
+        printf("%s\r\n", cpBuf);
+        cpBuf = cp;
+    } else {
+        /* no HTTP status code */
+        if ((cp = getenv("SERVER_PROTOCOL")) == NULL)
+            cp = "HTTP/1.0";
+        printf("%s 200 OK\r\n", cp);
+    }
 
     if (!HTTP_HeaderLineExists(cpBuf, "Server")) {
         if ((cp = getenv("SERVER_SOFTWARE")) == NULL)
             cp = "unknown-server/0.0";
-        printf("Server: %s %s Perl/%s\n", cp, ePerl_WebID, AC_perl_vers);
+        printf("Server: %s %s Perl/%s\r\n", cp, eperl_version.v_web, AC_perl_vers);
     }
 
     if (!HTTP_HeaderLineExists(cpBuf, "Date"))
-        printf("Date: %s\n", WebTime());
+        printf("Date: %s\r\n", WebTime());
 
     if (!HTTP_HeaderLineExists(cpBuf, "Connection"))
-        printf("Connection: close\n");
+        printf("Connection: close\r\n");
 
-    return;
+    return cpBuf;
 }
 
 /*
@@ -242,7 +262,8 @@
     if (cps == NUL) 
         strcpy(file, "/");
     else 
-        strcpy(file, cps);
+        strncpy(file, cps, sizeof(file));
+    file[sizeof(file)-1] = NUL;
     return file;
 }
 
@@ -254,7 +275,7 @@
     struct hostent *he;
     struct sockaddr_in sar;
     struct protoent *pe;
-    char cmd[1024];
+    char *cmd;
     char buf[1024];
     char newurl[8192];
     char *host;
@@ -292,13 +313,19 @@
         return NULL;
 
     /* form the HTTP/1.0 request */
-    sprintf(cmd, "GET %s HTTP/1.0\n", file);
-    sprintf(cmd+strlen(cmd), "Host: %s:%s\n", host, port);
-    sprintf(cmd+strlen(cmd), "User-Agent: %s\n", ePerl_WebID);
-    sprintf(cmd+strlen(cmd), "\n");
+    cmd = malloc(64 + strlen(file) + strlen(host) +
+                      strlen(port) + strlen(eperl_version.v_web));
+    if (cmd == NULL)
+        return NULL;
+    /* cmd has enough space */
+    sprintf(cmd, "GET %s HTTP/1.0\r\n", file);
+    sprintf(cmd+strlen(cmd), "Host: %s:%s\r\n", host, port);
+    sprintf(cmd+strlen(cmd), "User-Agent: %s\r\n", eperl_version.v_web);
+    sprintf(cmd+strlen(cmd), "\r\n");
 
     /* send the request */
     write(s, cmd, strlen(cmd));
+    free(cmd);
 
     /* convert the file descriptor to a FILE pointer */
     fp = fdopen(s, "r");
@@ -330,7 +357,8 @@
                     for (cp2 = cp; *cp2 != ' ' && *cp2 != '\t' && *cp2 != '\n' && *cp2 != NUL; cp2++)
                         ;
                     *cp2 = NUL;
-                    strcpy(newurl, cp);
+                    strncpy(newurl, cp, sizeof(newurl));
+                    newurl[sizeof(newurl)-1] = NUL;
                     break;
                 }
             }
